/********************************************************************
 *	ȈՃj^
 ********************************************************************
 */
#include <string.h>

#include "NVMem.h"
#include "serial1.h"

#include "hidcmd.h"
#include "monit.h"



/********************************************************************
 *	XCb`
 ********************************************************************
 */

/********************************************************************
 *	`
 ********************************************************************
 */
#define	DEVID	0x32

#define	VER_H	1
#define	VER_L	1

#if	_ROMADRS || _APPLICATION
#define	DEV_LOADER	0
#else
#define	DEV_LOADER	1
#endif

#define	MONIT_SOF		0x01
#define	REPLY_REPORT	0xaa

//
// ===        STM32ȊOłFlash Programming .
//
#if	0	//ndef	SUBMDL_STM32F103

UINT	NVMemOperation(UINT nvmop);
UINT	NVMemErasePage(void* address);
UINT	NVMemWriteWord(void* address, UINT data);
UINT	NVMemWriteRow(void* address, void* data);
UINT	NVMemClearError(void);

#endif

void	reset_device(int adrs);

/********************************************************************
 *	f[^
 ********************************************************************
 */

//	AVRݗpReNXg.
uchar  page_mode;
uchar  page_addr;
uchar  page_addr_h;

//	f[^胂[h̐ݒ.
uchar   poll_mode;	// 00=ݒ  0xa0=AiOTv  0xc0=fW^Tv
// 0xc9=runR}h^[~l[g
uchar  *poll_addr;	//

//	R}h̕ԐMKvȂ1Zbg.
uchar	ToPcRdy;

uchar	puts_mode;

uchar 	puts_buf[64];
uchar 	puts_ptr;

uchar	poll_wptr;
uchar	poll_rptr;
uchar	poll_buf[256];


#define	Firm_top	0x1d000000

// 							   BMXPFMSZ:I/O(R):  FlashROM̃TCY
#define	Firm_end	(Firm_top + BMXPFMSZ)
//#define	Firm_end	0x1d008000

#define	FLASH_END_ADR	BMXPFMSZ		//ۂɂ̓TCY.
//#define	FLASH_END_ADR	0x8000

int		total_errs=0;
static  int test_adr0=0;

static  volatile char s_linecoding = 0;		//	baudrateύXꂽ.


Packet PacketFromPC;			//̓pPbg 64byte
Packet PacketToPC;				//o̓pPbg 64byte

#define	Cmd0	PacketFromPC.cmd

/********************************************************************
 *
 ********************************************************************
 */
/*
int	align_size(int adr,int align)
{
	return 	(adr + align - 1) & (-align) ;	// align byteEɍ킹.
}
*/
/********************************************************************
 *
 ********************************************************************
 */
static	inline	int	UARTputpacket(uchar *buf,int len)
{
	UARTwrite(buf,len);
	return len;
}

/********************************************************************
 *
 ********************************************************************
 */
int check_flash_adrs(int adrs)
{
	if( (adrs >= Firm_top)&&(adrs < Firm_end) )	return 1;	// VALID!
	return 0;	// INVALID.
}
/********************************************************************
 *	ISPW[ CN[h.
 ********************************************************************
 */
//#include "usi_pic18s.h"

static void isp_command(uchar *data)
{
	uchar i;
	for (i=0; i<4; i++) {
		PacketToPC.raw[i]=usi_trans(data[i]);
	}
}

/********************************************************************
 *	FLASḦ(9d00_0000,9d00_0000 + ea)̍ŏI݃|CgT.
 ********************************************************************
 */
int	search_flash_end(int ea)
{
	int *p  = (int *) (0x9d000000+ea);
	int cnt = ea >> 2;
	int i;
	for(i=0;i<cnt;i++) {
		p--;
		if(*p != (-1)) break;	// 0xffff_ffff ?
	}
	return (int)p;
}

/********************************************************************
 *	ڑeXg̕ԓ
 ********************************************************************
 */
void cmd_echo(void)
{
	int *fl_stat = &PacketToPC.rawint[2];
	PacketToPC.raw[1]=DEVID;				// DeviceID
	PacketToPC.raw[2]=VER_L;				// version.L
	PacketToPC.raw[3]=VER_H;				// version.H
	PacketToPC.raw[4]=DEV_LOADER;			// bootloader
	PacketToPC.raw[5]=PacketFromPC.raw[1];	// ECHOBACK TEST

	fl_stat[0] = (FLASH_END_ADR);
	fl_stat[1] = (search_flash_end(FLASH_END_ADR));
	fl_stat[2] = (total_errs);

	total_errs=0;
	ToPcRdy = 1;
}

/********************************************************************
 *	[ǂݏoi32byteȏꊇj
 ********************************************************************
 */
static	inline	void cmd_peek_large_block(int adrs,int size)
{
	uchar *p = (uchar *)adrs;
	UARTputpacket(p,size);
}

/********************************************************************
 *	[ǂݏo
 ********************************************************************
 */
void cmd_peek(void)
{
	Packet *t = &PacketFromPC;
	int  size = (t->size);
	int  adrs = (t->adrs);
	int    i,subcmd;
	uchar  *pb;
	ushort *ph;
	uint   *pw;

	uchar  *tb;
	ushort *th;
	uint   *tw;

	subcmd = t->subcmd;

	if(size > PACKET_SIZE) {// 60byteȏ̘Aǂݏo͕ʏ.
		cmd_peek_large_block(adrs,size);
		return;
	}

	switch(subcmd) {         // ǂݏowɉ
	default:
	case MEM_BYTE:
		pb = (uchar *)adrs;
		tb = (uchar *)PacketToPC.raw;
		for(i=0; i<size; i++) {
			*tb++ = *pb++;
		}
		break;
	case MEM_HALF:
		ph = (ushort *)adrs;
		th = (ushort *)PacketToPC.rawint;
		for(i=0; i<size; i+=2) {
			*th++ = *ph++;
		}
		break;
	case MEM_WORD:
		pw = (uint *)adrs;
		tw = (uint *)PacketToPC.rawint;
		for(i=0; i<size; i+=4) {
			*tw++ = *pw++;
		}
		break;
	}

	UARTputpacket(PacketToPC.raw,PACKET_SIZE);

//	ToPcRdy = 1;
}
/********************************************************************
 *	[
 ********************************************************************
 */
void cmd_poke(void)
{
	Packet *t = &PacketFromPC;
	int  size = (t->size);
	int  adrs = (t->adrs);
	int  i,subcmd;

	uchar  *pb;
	ushort *ph;
	uint   *pw;

	uchar  *sb;
	ushort *sh;
	uint   *sw;

	subcmd = t->subcmd;

	switch(subcmd) {	// ݕwɉ
	default:
	case MEM_BYTE:
		pb = (uchar *)adrs;
		sb = (uchar *)t->data;
		for(i=0; i<size; i++) {
			*pb++ = *sb++;
		}
		break;
	case MEM_HALF:
		ph = (ushort *)adrs;
		sh = (ushort *)t->data;
		for(i=0; i<size; i+=2) {
			*ph++ = *sh++;
		}
		break;
	case MEM_WORD:
		pw = (uint *)adrs;
		sw = (uint *)t->data;
		for(i=0; i<size; i+=4) {
			*pw++ = *sw++;
		}
		break;
	}
}

/********************************************************************
 *	FLASH̃y[WPʏ.	(Page̐擪adrs) TCY͈Ö.
 ********************************************************************
 */
void cmd_page_erase()
{
	int adrs = PacketFromPC.adrs  & 0x1fffffff;
	if( check_flash_adrs(adrs)) {
		NVMemErasePage((void*) adrs);
	}
	ToPcRdy = 1;		//̂߁A_~[f[^Ԃ.
}

static	inline	void FLASH_Lock()
{
	NVMCONbits.WREN = 0;		//clear WREN bit 
}
static	inline	void FLASH_Unlock()
{
	NVMemClearError();
}
/********************************************************************
 *	FLASH݂̏bN/AbN.(size[ȂAbN)
 ********************************************************************
 */
static	inline	void cmd_flash_lock()
{
	if(PacketFromPC.size) {
		FLASH_Lock();
	} else {
		/* Unlock the internal flash */
		FLASH_Unlock();
	}
}

/********************************************************************
 *	FLASH̃y[WPʏ.	(͏adrssize)
 ********************************************************************
  STM32ł́AwordPʂŏ݂\. (flushsv)

  ̃}CR(LPCȂ)ł́A
  	ۂɂRAM̃y[Wobt@wordPʂł߂ĂāA
  	Ōsize=0w肵ăy[Wobt@ꔭ݂ɂȂ邱Ƃ.
 

 */
void cmd_page_write()
{
	int  *p = PacketFromPC.data;
	int   i;
	int   size = (PacketFromPC.size);
	int	   adr = (PacketFromPC.adrs) & 0x1fffffff;

	// bytewordɕϊĂ.
	size = (size+3) >> 2;		// size 4bytePʂɌ.

//	if(size==0) {				// size  0 ̂Ƃ͏flush.
//		FLASH_ProgramPage(adr);	// STM32Ɍsv(_~[֐)
//		return ;
//	}

	for(i=0; i<size; i++) {
		if( check_flash_adrs(adr) ) {
			NVMemWriteWord((void*) adr, *p);
//			FLASH_ProgramWord(adr, *p);	// STM32ł͒FLUSHɏ.
		}								// ̃}CRł́Ay[Wobt@ɋL^.
		p++;
		adr+=4;
	}
}

/********************************************************************
 *	Ԓnw̎s
 ********************************************************************
 */
static	inline	void call_func(int adrs)
{
	void (*func)(void);
	func = (void (*)()) adrs;

	func();
}



/********************************************************************
 *	Ԓnw̎s
 ********************************************************************
 */
static	inline	void cmd_exec()
{
	int bootflag = (PacketFromPC.size);
	int	    adrs = (PacketFromPC.adrs);
	if(	bootflag ) {
		reset_device(adrs);
	}
	call_func(adrs);
}

#if	APPLICATION_MODE
/********************************************************************
 *	puts zXgɕԑ.
 ********************************************************************
 */
void cmd_get_string(void)
{
	PacketToPC.raw[0] =  puts_mode;	//'p';		/* R}hsHOSTɒm点. */
	PacketToPC.raw[1] =  puts_ptr;	// .
	memcpy( (void*)&PacketToPC.raw[2] , (void*)puts_buf , puts_ptr & 0x3f);	//.
	puts_ptr = 0;
	ToPcRdy = 1;
}
/********************************************************************
 *	[U[`֐̎s.
 ********************************************************************
 */
void cmd_user_cmd(void)
{
	puts_ptr = 0;
	puts_mode = 'p';
	user_cmd(BSWAP32(PacketFromPC.adrs));
	puts_mode = 'q';
}
#endif

/********************************************************************
 *	1mSPʂ̒xs.
 ********************************************************************
 */
void cmd_wait_msec(void)
{
	uchar ms = PacketFromPC.raw[1];	// '-dN'
	if(ms) {
		wait_ms(ms);
	}
}

/********************************************************************
 *	j^R}hMƎs.
 ********************************************************************
 */
static	inline void ProcessIO(void)
{
	// ԓpPbgł邱ƁAA
	// Ώۂ̎Mf[^.
	
	//Mf[^΁AMf[^󂯎.
	PacketToPC.raw[0]=Cmd0;		// CMD ECHOBACK
	switch(Cmd0) {
	 case HIDASP_PEEK: 		{cmd_peek();break;}			// [ǂݏo.
	 case HIDASP_POKE: 		{cmd_poke();break;}			// [.
	 case HIDASP_JMP: 		{cmd_exec();break;}			// ċN.
	 case HIDASP_PAGE_ERASE:{cmd_page_erase();break;}	//Flash.
	 case HIDASP_PAGE_WRITE:{cmd_page_write();break;}	//Flash.
	 case HIDASP_FLASH_LOCK:{cmd_flash_lock();break;}	//FlashLock.
	 case HIDASP_TEST: 		{cmd_echo();break;}			// ڑeXg.

#if	APPLICATION_MODE
	 case HIDASP_GET_STRING:{cmd_get_string();break;}
	 case HIDASP_USER_CMD:  {cmd_user_cmd();break;}
#endif
	 default: break;
	}
	// KvȂAԓpPbgC^vg](EP1)ŃzXgPCɕԋp.
	if( ToPcRdy ) {
		UARTputpacket(PacketToPC.raw,PACKET_SIZE);
		ToPcRdy = 0;
	}
}
/********************************************************************
 *	C
 ********************************************************************
 */
void UARTmonit(void)
{
	int rc=0;
	while(1){
		// 擪byte0x01łȂ΁AG[.
		int ch = Serial1GetKey();
		if(	ch != 0x01 ) return;		// ErrorI.

		do {	//	PACKETM҂
			rc = UARTgetpacket(PacketFromPC.raw,PACKET_SIZE);
		}while(rc==0);

		// PACKET.
		ProcessIO();
	}
}

/********************************************************************
 *
 ********************************************************************
 */
